/*
 * 商学院推广素材
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SchoolMaterialsController : BaseController
    {
        public SchoolMaterialsController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商学院推广素材列表

        /// <summary>
        /// 根据条件查询商学院推广素材列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SchoolMaterials data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询商学院推广素材列表

        /// <summary>
        /// 商学院推广素材列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SchoolMaterials data, string UserIdSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客
            if (!string.IsNullOrEmpty(UserIdSelect))
            {
                condition += " and UserId=" + UserIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("SchoolMaterials", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";

            }
            return Json(obj);
        }

        #endregion

        #region 增加商学院推广素材

        /// <summary>
        /// 增加或修改商学院推广素材信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加商学院推广素材

        /// <summary>
        /// 增加或修改商学院推广素材信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SchoolMaterials data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("MakerCode", data.MakerCode); //创客编号
            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("TextDetail", data.TextDetail); //文字描述
            Fields.Add("Pic", data.Pic); //图片
            Fields.Add("Url", data.Url); //链接地址
            Fields.Add("UrlParam", data.UrlParam); //链接参数
            Fields.Add("Contents", data.Contents); //详细内容

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Add("SchoolMaterials", Fields, 0);
            AddSysLog(data.Id.ToString(), "SchoolMaterials", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商学院推广素材

        /// <summary>
        /// 增加或修改商学院推广素材信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SchoolMaterials editData = db.SchoolMaterials.FirstOrDefault(m => m.Id == Id) ?? new SchoolMaterials();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商学院推广素材

        /// <summary>
        /// 增加或修改商学院推广素材信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SchoolMaterials data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("MakerCode", data.MakerCode); //创客编号
            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("TextDetail", data.TextDetail); //文字描述
            Fields.Add("Pic", data.Pic); //图片
            Fields.Add("Url", data.Url); //链接地址
            Fields.Add("UrlParam", data.UrlParam); //链接参数
            Fields.Add("Contents", data.Contents); //详细内容

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolMaterials", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SchoolMaterials", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商学院推广素材信息

        /// <summary>
        /// 删除商学院推广素材信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMaterials", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolMaterials", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMaterials", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolMaterials", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SchoolMaterials", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("SchoolMaterials", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).Sort("SchoolMaterials", Sort, Id);

            AddSysLog(Id.ToString(), "SchoolMaterials", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.SchoolMaterials.Add(new SchoolMaterials()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "SchoolMaterials", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SchoolMaterials data, string UserIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客
            if (!string.IsNullOrEmpty(UserIdSelect))
            {
                condition += " and UserId=" + UserIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("SchoolMaterials", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SchoolMaterials", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
